<html>
<head>
<title>OgreStaticFaceGroup.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreStaticFaceGroup.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreStaticFaceGroup_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __StaticFaceGroup_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __StaticFaceGroup_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlane_8h.html">OgrePlane.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgrePatchSurface_8h.html">OgrePatchSurface.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00045"></a><a class="code" href="group__Scene.html#ga7c11c8a17d7bbfc5aab6f982fb0d7f38">00045</a>     <span class="keyword">enum</span> <a class="code" href="group__Scene.html#ga7c11c8a17d7bbfc5aab6f982fb0d7f38" title="A type of face group, i.e.">FaceGroupType</a> {
<a name="l00046"></a><a class="code" href="group__Scene.html#gga7c11c8a17d7bbfc5aab6f982fb0d7f38a06ae7e34bd024924db27d7a490c545e4">00046</a>         <a class="code" href="group__Scene.html#gga7c11c8a17d7bbfc5aab6f982fb0d7f38a06ae7e34bd024924db27d7a490c545e4">FGT_FACE_LIST</a>,
<a name="l00047"></a><a class="code" href="group__Scene.html#gga7c11c8a17d7bbfc5aab6f982fb0d7f38ab0cfe6b33db8e2804a5f50ae51d59ff5">00047</a>         <a class="code" href="group__Scene.html#gga7c11c8a17d7bbfc5aab6f982fb0d7f38ab0cfe6b33db8e2804a5f50ae51d59ff5">FGT_PATCH</a>,
<a name="l00048"></a><a class="code" href="group__Scene.html#gga7c11c8a17d7bbfc5aab6f982fb0d7f38a8d46b5184ac4f071e0f287f89e1b253b">00048</a>         <a class="code" href="group__Scene.html#gga7c11c8a17d7bbfc5aab6f982fb0d7f38a8d46b5184ac4f071e0f287f89e1b253b">FGT_UNKNOWN</a>
<a name="l00049"></a>00049     };
<a name="l00050"></a>00050 
<a name="l00069"></a><a class="code" href="structOgre_1_1StaticFaceGroup.html">00069</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1StaticFaceGroup.html" title="Collects a group of static i.e.">StaticFaceGroup</a> {
<a name="l00070"></a>00070         <span class="comment">// Type of face group.</span>
<a name="l00071"></a><a class="code" href="structOgre_1_1StaticFaceGroup.html#abc91f43284e36aa2376f4d54078f0480">00071</a>         <a class="code" href="group__Scene.html#ga7c11c8a17d7bbfc5aab6f982fb0d7f38" title="A type of face group, i.e.">FaceGroupType</a> <a class="code" href="structOgre_1_1StaticFaceGroup.html#abc91f43284e36aa2376f4d54078f0480">fType</a>;
<a name="l00072"></a>00072 
<a name="l00074"></a><a class="code" href="structOgre_1_1StaticFaceGroup.html#aa58eb0dbf0fdf7e625c80e7dbb0e76f9">00074</a>         <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1StaticFaceGroup.html#aa58eb0dbf0fdf7e625c80e7dbb0e76f9" title="Is this a sky surface?">isSky</a>;
<a name="l00075"></a>00075 
<a name="l00079"></a><a class="code" href="structOgre_1_1StaticFaceGroup.html#a09215495af768e8a68b20cf1a937af3a">00079</a>         <span class="keywordtype">int</span> <a class="code" href="structOgre_1_1StaticFaceGroup.html#a09215495af768e8a68b20cf1a937af3a" title="Index into a buffer containing vertex definitions.">vertexStart</a>;
<a name="l00080"></a>00080 
<a name="l00085"></a><a class="code" href="structOgre_1_1StaticFaceGroup.html#a4b1e2bb83673099b9d2459a1bb67f429">00085</a>         <span class="keywordtype">int</span> <a class="code" href="structOgre_1_1StaticFaceGroup.html#a4b1e2bb83673099b9d2459a1bb67f429" title="The range of vertices in the buffer this facegroup references.">numVertices</a>;
<a name="l00086"></a>00086 
<a name="l00094"></a><a class="code" href="structOgre_1_1StaticFaceGroup.html#a3f73219edf1201e9a3c769f9ccc672bf">00094</a>         <span class="keywordtype">int</span> <a class="code" href="structOgre_1_1StaticFaceGroup.html#a3f73219edf1201e9a3c769f9ccc672bf" title="Index into a buffer containing vertex indices.">elementStart</a>;
<a name="l00095"></a>00095 
<a name="l00099"></a><a class="code" href="structOgre_1_1StaticFaceGroup.html#a2dba19f0f06565cd111206a4a673239c">00099</a>         <span class="keywordtype">int</span> <a class="code" href="structOgre_1_1StaticFaceGroup.html#a2dba19f0f06565cd111206a4a673239c" title="The number of vertex indices.">numElements</a>;
<a name="l00100"></a>00100 
<a name="l00105"></a><a class="code" href="structOgre_1_1StaticFaceGroup.html#a697d56998dccec97a4670930ea7c2a41">00105</a>         <span class="keywordtype">int</span> <a class="code" href="structOgre_1_1StaticFaceGroup.html#a697d56998dccec97a4670930ea7c2a41" title="Handle to material used by this group.">materialHandle</a>;
<a name="l00106"></a>00106 
<a name="l00107"></a><a class="code" href="structOgre_1_1StaticFaceGroup.html#ad258e1806394cbd8b2efe7f39d3a7296">00107</a>         <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> <a class="code" href="structOgre_1_1StaticFaceGroup.html#ad258e1806394cbd8b2efe7f39d3a7296">plane</a>;
<a name="l00108"></a>00108 
<a name="l00110"></a><a class="code" href="structOgre_1_1StaticFaceGroup.html#a42cad07e5dea1a57a10304dcd7b7810b">00110</a>         <a class="code" href="classOgre_1_1PatchSurface.html" title="A surface which is defined by curves of some kind to form a patch, e.g.">PatchSurface</a>* <a class="code" href="structOgre_1_1StaticFaceGroup.html#a42cad07e5dea1a57a10304dcd7b7810b" title="Patch surface (only applicable when fType = FGT_PATCH)">patchSurf</a>;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="structOgre_1_1StaticFaceGroup.html#ae57aba80895c22bb02f633d02be64edb">00113</a>         <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="structOgre_1_1StaticFaceGroup.html#ae57aba80895c22bb02f633d02be64edb">operator&lt;&lt;</a>(std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="structOgre_1_1StaticFaceGroup.html" title="Collects a group of static i.e.">StaticFaceGroup</a>&amp; s)
<a name="l00114"></a>00114         {
<a name="l00115"></a>00115             o &lt;&lt; <span class="stringliteral">&quot;StaticFaceGroup(&quot;</span>;
<a name="l00116"></a>00116             <span class="keywordflow">if</span> (s.<a class="code" href="structOgre_1_1StaticFaceGroup.html#abc91f43284e36aa2376f4d54078f0480">fType</a> == <a class="code" href="group__Scene.html#gga7c11c8a17d7bbfc5aab6f982fb0d7f38a06ae7e34bd024924db27d7a490c545e4">FGT_FACE_LIST</a>)
<a name="l00117"></a>00117             {
<a name="l00118"></a>00118                 o &lt;&lt; <span class="stringliteral">&quot;faceList, numVertices=&quot;</span> &lt;&lt; s.<a class="code" href="structOgre_1_1StaticFaceGroup.html#a4b1e2bb83673099b9d2459a1bb67f429" title="The range of vertices in the buffer this facegroup references.">numVertices</a> &lt;&lt; <span class="stringliteral">&quot;, vertexStart=&quot;</span> &lt;&lt; s.<a class="code" href="structOgre_1_1StaticFaceGroup.html#a09215495af768e8a68b20cf1a937af3a" title="Index into a buffer containing vertex definitions.">vertexStart</a>;
<a name="l00119"></a>00119                 o &lt;&lt; <span class="stringliteral">&quot;, numElements=&quot;</span> &lt;&lt; s.<a class="code" href="structOgre_1_1StaticFaceGroup.html#a2dba19f0f06565cd111206a4a673239c" title="The number of vertex indices.">numElements</a> &lt;&lt; <span class="stringliteral">&quot;, elementStart=&quot;</span> &lt;&lt; s.<a class="code" href="structOgre_1_1StaticFaceGroup.html#a3f73219edf1201e9a3c769f9ccc672bf" title="Index into a buffer containing vertex indices.">elementStart</a>;
<a name="l00120"></a>00120                 o &lt;&lt; <span class="stringliteral">&quot;, normal=&quot;</span> &lt;&lt; s.<a class="code" href="structOgre_1_1StaticFaceGroup.html#ad258e1806394cbd8b2efe7f39d3a7296">plane</a>.<a class="code" href="classOgre_1_1Plane.html#a3f97462d3822f6add8c070048f6c2d92">normal</a>;
<a name="l00121"></a>00121             }
<a name="l00122"></a>00122             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (s.<a class="code" href="structOgre_1_1StaticFaceGroup.html#abc91f43284e36aa2376f4d54078f0480">fType</a> == <a class="code" href="group__Scene.html#gga7c11c8a17d7bbfc5aab6f982fb0d7f38ab0cfe6b33db8e2804a5f50ae51d59ff5">FGT_PATCH</a>)
<a name="l00123"></a>00123             {
<a name="l00124"></a>00124                 o &lt;&lt; <span class="stringliteral">&quot;bezierPatch, numVertices=&quot;</span> &lt;&lt; s.<a class="code" href="structOgre_1_1StaticFaceGroup.html#a4b1e2bb83673099b9d2459a1bb67f429" title="The range of vertices in the buffer this facegroup references.">numVertices</a> &lt;&lt; <span class="stringliteral">&quot;, vertexStart=&quot;</span> &lt;&lt; s.<a class="code" href="structOgre_1_1StaticFaceGroup.html#a09215495af768e8a68b20cf1a937af3a" title="Index into a buffer containing vertex definitions.">vertexStart</a>;
<a name="l00125"></a>00125                 <span class="comment">// TODO</span>
<a name="l00126"></a>00126             }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128             o &lt;&lt; <span class="stringliteral">&quot;, materialHandle=&quot;</span> &lt;&lt; s.<a class="code" href="structOgre_1_1StaticFaceGroup.html#a697d56998dccec97a4670930ea7c2a41" title="Handle to material used by this group.">materialHandle</a>;
<a name="l00129"></a>00129             o &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131             <span class="keywordflow">return</span> o;
<a name="l00132"></a>00132         }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135     };
<a name="l00139"></a>00139 } <span class="comment">// namespace</span>
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
